#include "../stdafx.h"
#include <string.h>
#include "MultiDllOutput.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CMultiDllOutput::~CMultiDllOutput()
{
	CString dllOutKey = "";
	dllOutKey.Format(_T("dllOutName%d"), listDllOutput.GetSize());
	AfxGetApp()->WriteProfileString(_T("Preferences"), dllOutKey, _T("NONE"));
	do
	{
		currentDllOutput = (CDllOutput *)listDllOutput[listDllOutput.GetSize() - 1];
		dllOutKey.Format(_T("dllOutName%d"), listDllOutput.GetSize() - 1);
		AfxGetApp()->WriteProfileString(_T("Preferences"), dllOutKey, currentDllOutput->GetFilePath());
		currentDllOutput->Quit();
		delete currentDllOutput;
		currentDllOutput = NULL;
		listDllOutput.SetSize(listDllOutput.GetSize() - 1);
	}
	while (listDllOutput.GetSize() != 0);
}

CMultiDllOutput::CMultiDllOutput(HWND hWnd)
{
	CString dllOutName = "";
	CString dllOutKey = "";
	bool alreadyLoad = false;
	int i = 0;
	do
	{
		listDllOutput.SetSize(listDllOutput.GetSize() + 1);
		dllOutKey.Format(_T("dllOutName%d"), i);
		dllOutName = AfxGetApp()->GetProfileString(_T("Preferences"), dllOutKey, _T(""));
		if (dllOutName == "NONE")
			dllOutName = "";
		if (((dllOutName == "" || dllOutName == "STANDARD") && !alreadyLoad) || ((dllOutName != "" && dllOutName != "STANDARD")))
		{
			if (dllOutName == "STANDARD" || dllOutName == "")
			{
				currentDllOutput = new CDllOutput("", hWnd);
				alreadyLoad = true;
			}
			else
				currentDllOutput = new CDllOutput(dllOutName, hWnd);
			if (dllOutName != currentDllOutput->GetFilePath() && dllOutName != "STANDARD" && dllOutName != "")
			{
				delete currentDllOutput;
				listDllOutput.SetSize(listDllOutput.GetSize() - 1);
				currentDllOutput = NULL;
			}
			else
			{
				currentDllOutput->Init();
				listDllOutput[listDllOutput.GetSize() - 1] = (CObject *)currentDllOutput;
			}
		}
		else
			listDllOutput.SetSize(listDllOutput.GetSize() - 1);
		i++;
	}
	while (dllOutName.GetLength() != 0);
	currentDllOutput = (CDllOutput *)listDllOutput[0];
}

int CMultiDllOutput::GetVersion()   	// module version (OUT_VER)
{
	currentDllOutput = (CDllOutput *)listDllOutput[0];
	return currentDllOutput->GetVersion();
}

TCHAR* CMultiDllOutput::GetDescription()	 // description of module, with version string
{
	currentDllOutput = (CDllOutput *)listDllOutput[0];
	return currentDllOutput->GetDescription();
}
int CMultiDllOutput::GetId()			// module id. each output module gets its own. non-nullsoft modules should
{
	currentDllOutput = (CDllOutput *)listDllOutput[0];
	return currentDllOutput->GetId();
}


void CMultiDllOutput::SethMainWindow(HWND hWnd) 	 // winamp's main window (filled in by winamp)
{
	for (int i = 0; i < listDllOutput.GetSize(); i++)
	{
		CDllOutput* curDllOutput = (CDllOutput*)listDllOutput[i];
		curDllOutput->SethMainWindow(hWnd);
	}
}

int CMultiDllOutput::Open(int samplerate, int numchannels, int bitspersamp, int bufferlenms, int prebufferms)
	// returns >=0 on success, <0 on failure
	// NOTENOTENOTE: bufferlenms and prebufferms are ignored in most if not all output plug-ins. 
	//    ... so don't expect the max latency returned to be what you asked for.
	// returns max latency in ms (0 for diskwriters, etc)
	// bufferlenms and prebufferms must be in ms. 0 to use defaults. 
	// prebufferms must be <= bufferlenms
{
	currentDllOutput = (CDllOutput *)listDllOutput[0];
	return currentDllOutput->Open(samplerate, numchannels, bitspersamp, bufferlenms, prebufferms);
}

void CMultiDllOutput::Close()  // close the ol' output device.
{
	currentDllOutput = (CDllOutput *)listDllOutput[0];
	currentDllOutput->Close();
}

int CMultiDllOutput::Write(char* buf, int len)
	// 0 on success. Len == bytes to write (<= 8192 always). buf is straight audio data. 
	// 1 returns not able to write (yet). Non-blocking, always.
{
	currentDllOutput = (CDllOutput *)listDllOutput[0];
	return currentDllOutput->Write(buf, len);
}

int CMultiDllOutput::CanWrite() // returns number of bytes possible to write at a given time. 
	// Never will decrease unless you call Write (or Close, heh)
{
	currentDllOutput = (CDllOutput *)listDllOutput[0];
	return currentDllOutput->CanWrite();
}

int CMultiDllOutput::IsPlaying() // non0 if output is still going or if data in buffers waiting to be
	// written (i.e. closing while IsPlaying() returns 1 would truncate the song
{
	currentDllOutput = (CDllOutput *)listDllOutput[0];
	return currentDllOutput->IsPlaying();
}

int CMultiDllOutput::Pause(int pause) // returns previous pause state
{
	currentDllOutput = (CDllOutput *)listDllOutput[0];
	return currentDllOutput->Pause(pause);
}


void CMultiDllOutput::SetVolume(int volume) // volume is 0-255
{
	currentDllOutput = (CDllOutput *)listDllOutput[0];
	currentDllOutput->SetVolume(volume);
}
void CMultiDllOutput::SetPan(int pan) // pan is -128 to 128
{
	currentDllOutput = (CDllOutput *)listDllOutput[0];
	currentDllOutput->SetPan(pan);
}

void CMultiDllOutput::Flush(int t) // flushes buffers and restarts output at time t (in ms) 
	// (used for seeking)
{
	currentDllOutput = (CDllOutput *)listDllOutput[0];
	currentDllOutput->Flush(t);
}

int CMultiDllOutput::GetOutputTime() // returns played time in MS
{
	currentDllOutput = (CDllOutput *)listDllOutput[0];
	return currentDllOutput->GetOutputTime();
}
int CMultiDllOutput::GetWrittenTime() // returns time written in MS (used for synching up vis stuff)
{
	currentDllOutput = (CDllOutput *)listDllOutput[0];
	return currentDllOutput->GetWrittenTime();
}

Out_Module* CMultiDllOutput::GetOut_Module()
{
	currentDllOutput = (CDllOutput *)listDllOutput[0];
	return currentDllOutput->GetOut_Module();
}

int CMultiDllOutput::GetSize() // return the number of loaded output
{
	return listDllOutput.GetSize();
}

CDllOutput* CMultiDllOutput::getDllOutput(int pos) //Return the DllOutput at pos
{
	return (CDllOutput *)listDllOutput[pos];
}

void CMultiDllOutput::UnLoad(int pos) //Unload the DllOutput at pos
{
	if (pos < listDllOutput.GetSize())
	{
		CDllOutput* output = (CDllOutput*)listDllOutput[pos];
		delete output;
		for (int i = pos; i < listDllOutput.GetSize() - 1; i++)
			listDllOutput[i] = listDllOutput[i + 1];
		listDllOutput.SetSize(listDllOutput.GetSize() - 1);
		currentDllOutput = (CDllOutput *)listDllOutput[0];
	}
	currentDllOutput = (CDllOutput *)listDllOutput[0];
}

void CMultiDllOutput::Load(CString file, HWND hWnd) //Load the DllOutput
{
	CDllOutput* output = new CDllOutput(file, hWnd);
	if (output->GetFilePath() != "STANDARD")
	{
		listDllOutput.SetSize(listDllOutput.GetSize() + 1);
		listDllOutput[listDllOutput.GetSize() - 1] = output;
	}
	else
		delete output;
	currentDllOutput = (CDllOutput *)listDllOutput[0];
}

void CMultiDllOutput::UpDllOutput(int pos) //Up the DllOutput in the list
{
	if (pos == 0)
		return;
	CMultiDllOutput* output = (CMultiDllOutput*)listDllOutput[pos];
	listDllOutput[pos] = listDllOutput[pos - 1];
	listDllOutput[pos - 1] = output;
}
