// SettingsDialogGen.cpp : fichier d'implmentation
//

#include "stdafx.h"
#include "resource.h"   	// main symbols
#include "SysTrayPlay.h"
#include "SettingsDialog.h"
#include "SettingsDialogGen.h"
#include "MainHelper.h"
#include "MainWnd.h"
#include "volume.h"
#include "Gen/MultiDllGen.h"
#include "out/MultiDlloutput.h"
#include "WAEmuwnd.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// Bote de dialogue CSettingsDialogGen


IMPLEMENT_MENUXP(CSettingsDialogGen, CPropertyPage);

IMPLEMENT_DYNAMIC(CSettingsDialogGen, CPropertyPage)

CSettingsDialogGen::CSettingsDialogGen() : CPropertyPage(CSettingsDialogGen::IDD)
{
	m_current = -1;
}

CSettingsDialogGen::~CSettingsDialogGen()
{
}

void CSettingsDialogGen::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	CMenuXP::SetXPLookNFeel(this, pMainFrame->XPLookNFeel);
	DDX_Control(pDX, IDC_CONFIG_GEN, m_btnConfiguration);
	DDX_Control(pDX, IDC_LOAD_GEN, m_btnLoad);
	DDX_Control(pDX, IDC_UNLOAD_GEN, m_btnUnload);
	DDX_Control(pDX, IDC_LIST_GEN, m_ListGen);
}

BOOL CSettingsDialogGen::OnInitDialog()
{
	CPropertyPage::OnInitDialog();
	m_Helper.translateDlgItemText(this, IDC_CONFIG_GEN);
	m_Helper.translateDlgItemText(this, IDC_LOAD_GEN);
	m_Helper.translateDlgItemText(this, IDC_UNLOAD_GEN);

	OnInitList();
	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CSettingsDialogGen::OnInitList()
{
	for (int i = 0; i < stdGen->GetSize(); i++)
	{
		CDllGen* gen = stdGen->getDllGen(i);
		CString desc = "";
		desc.Format(_T("%s (%s)"), gen->GetDescription(), gen->GetFileName());
		m_ListGen.AddString(desc);
		m_ListGen.SetCurSel(i);
		m_current = i;
	}
}

void CSettingsDialogGen::OnOK()
{
	UpdateData(TRUE);

	CString dllInKey = "";
	for (int i = 0; i < stdGen->GetSize(); i++)
	{
		CDllGen* gen = stdGen->getDllGen(i);
		dllInKey.Format(_T("dllGenName%d"), i);
		AfxGetApp()->WriteProfileString(_T("Preferences"), dllInKey, gen->GetFilePath());
	}
	dllInKey.Format(_T("dllGenName%d"), stdGen->GetSize());
	AfxGetApp()->WriteProfileString(_T("Preferences"), dllInKey, _T("NONE"));
	CPropertyPage::OnOK();
}
BEGIN_MESSAGE_MAP(CSettingsDialogGen, CPropertyPage)
  ON_BN_CLICKED(IDC_CONFIG_GEN, OnBnClickedConfig)
  ON_BN_CLICKED(IDC_LOAD_GEN, OnBnClickedLoad)
  ON_BN_CLICKED(IDC_UNLOAD_GEN, OnBnClickedUnload)
  ON_MENUXP_MESSAGES()
END_MESSAGE_MAP()


// Gestionnaires de messages CSettingsDialogGen
void CSettingsDialogGen::OnBnClickedConfig()
{
	for (int i = stdGen->GetSize() - 1; i >= 0; i--)
	{
		if (m_ListGen.GetSel(i) != 0)
		{
			CDllGen* gen = stdGen->getDllGen(i);
			gen->Config();
		}
	}
}

void CSettingsDialogGen::OnBnClickedLoad()
{
	CString filter = "";
	CFileDialog dialog(TRUE, _T("dll"), _T(""), OFN_FILEMUSTEXIST, m_Helper.MyLoadString(IDS_OPENGEN));
	TCHAR buffer[_MAX_PATH*500 + 1];
	buffer[0] = '\0';
	dialog.m_ofn.lpstrFile = buffer;
	dialog.m_ofn.nMaxFile = _MAX_PATH * 500;
	if (dialog.DoModal() == IDOK)
	{
		int oldSize = stdGen->GetSize();
		stdGen->Load(dialog.GetPathName(), WAEmuWnd->m_hWnd);
		if (oldSize != stdGen->GetSize())
		{
			CDllGen* gen = stdGen->getDllGen(oldSize);
			CString desc = "";
			desc.Format(_T("%s (%s)"), gen->GetDescription(), gen->GetFileName());
			m_ListGen.AddString(desc);
		}
	}
}

void CSettingsDialogGen::OnBnClickedUnload()
{
	if (-1 < m_ListGen.GetCurSel() && m_ListGen.GetCurSel() < stdGen->GetSize())
	{
		int index = m_ListGen.GetCurSel();
		CDllGen* gen = stdGen->getDllGen(index);
		m_ListGen.DeleteString(index);
		stdGen->UnLoad(index);
		m_current = -1;
		m_ListGen.SetCurSel(m_current);
	}
}






