// ReplaygainDialog.cpp
//

#include "../stdafx.h"

#include "../wa_ipc.h"

#include "TagInfo.h"
#include "in_mpg123.h"

#include "HttpFile.h"
#include "ICYInfo.h"

#include "Param.h"
#include "ReplayGainDialog.h"
#include "PropertySheet.h"
#include "../MainHelper.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

void ShowDB(HWND hDlg, int Pos, UINT msgID)
{
	char StrBuff[16];
	char* Str = StrBuff;

	if (Pos > 0)
	{
		*Str++ = '+';
	}
	else if (Pos < 0)
	{
		*Str++ = '-';
	}
	else
	{
		*Str++ = '+';
		*Str++ = '/';
		*Str++ = '-';
	}

	Pos = abs(Pos);

	_itoa(Pos / 10, Str, 10);
	Str += strlen(Str);
	*Str++ = '.';
	_itoa(Pos - Pos / 10 * 10, Str, 10);
	Str += strlen(Str);
	*Str++ = ' ';
	*Str++ = 'd';
	*Str++ = 'B';
	*Str = '\0';

	SetDlgItemText(hDlg, msgID, StrBuff);
}

void reflect_setting(void);
void reflect_thread_setting(void);

BOOL CALLBACK in_replaygain_dialog_proc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_INITDIALOG:
		{
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_CH_REPLAYGAIN_ENABLE);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_CH_REPLAYGAIN_TAG_ID3V2);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_CH_REPLAYGAIN_TAG_APE);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_CH_REPLAYGAIN_TAG_LAME);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_CH_REPLAYGAIN_HARDLIMIT);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_LREPLAYGAIN_MODE);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_LREADTAG);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_LREPLAYGAIN_PREAMP);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_LFILES_WITH_REPLAYGAIN_INFO);
			m_HelperIn.translateDlgItemText(CWnd::FromHandle(hDlg), IDC_LFILES_WITHOUT_REPLAYGAIN_INFO);

			SendDlgItemMessage(hDlg, IDC_CH_REPLAYGAIN_ENABLE, BM_SETCHECK, prm->m_bReplayGainEnable ? BST_CHECKED : BST_UNCHECKED, 0);
			SendDlgItemMessage(hDlg, IDC_CH_REPLAYGAIN_TAG_ID3V2, BM_SETCHECK,
							   (prm->m_nReplayGainTag & REPLAYGAIN_TAG_ID3V2) ? BST_CHECKED : BST_UNCHECKED, 0);
			SendDlgItemMessage(hDlg, IDC_CH_REPLAYGAIN_TAG_APE, BM_SETCHECK,
							   (prm->m_nReplayGainTag & REPLAYGAIN_TAG_APE) ? BST_CHECKED : BST_UNCHECKED, 0);
			SendDlgItemMessage(hDlg, IDC_CH_REPLAYGAIN_TAG_LAME, BM_SETCHECK,
							   (prm->m_nReplayGainTag & REPLAYGAIN_TAG_LAME) ? BST_CHECKED : BST_UNCHECKED, 0);
			SendDlgItemMessage(hDlg, IDC_CH_REPLAYGAIN_HARDLIMIT, BM_SETCHECK, prm->m_bReplayGainHardLimit ? BST_CHECKED : BST_UNCHECKED, 0);

			SendDlgItemMessage(hDlg, IDC_TRACK_REPLAYGAIN_PREAMP_WITH_RG, TBM_SETRANGE, TRUE, MAKELONG(-120, 120));
			SendDlgItemMessage(hDlg, IDC_TRACK_REPLAYGAIN_PREAMP_WITH_RG, TBM_SETTIC, 0, 25);
			SendDlgItemMessage(hDlg, IDC_TRACK_REPLAYGAIN_PREAMP_WITH_RG, TBM_SETTICFREQ, 10, 0);
			SendDlgItemMessage(hDlg, IDC_TRACK_REPLAYGAIN_PREAMP_WITH_RG, TBM_SETPOS, TRUE, prm->m_nReplayGainPreAmpWithRG);
			ShowDB(hDlg, prm->m_nReplayGainPreAmpWithRG, IDC_ST_REPLAYGAIN_PREAMP_WITH_RG_DB);
			SendMessage(hDlg, WM_HSCROLL, TB_ENDTRACK, (LPARAM)GetDlgItem(hDlg, IDC_TRACK_REPLAYGAIN_PREAMP_WITH_RG));

			SendDlgItemMessage(hDlg, IDC_TRACK_REPLAYGAIN_PREAMP_WITHOUT_RG, TBM_SETRANGE, TRUE, MAKELONG(-120, 120));
			SendDlgItemMessage(hDlg, IDC_TRACK_REPLAYGAIN_PREAMP_WITHOUT_RG, TBM_SETTIC, 0, 25);
			SendDlgItemMessage(hDlg, IDC_TRACK_REPLAYGAIN_PREAMP_WITHOUT_RG, TBM_SETTICFREQ, 10, 0);
			SendDlgItemMessage(hDlg, IDC_TRACK_REPLAYGAIN_PREAMP_WITHOUT_RG, TBM_SETPOS, TRUE, prm->m_nReplayGainPreAmpWithoutRG);
			ShowDB(hDlg, prm->m_nReplayGainPreAmpWithoutRG, IDC_ST_REPLAYGAIN_PREAMP_WITHOUT_RG_DB);
			SendMessage(hDlg, WM_HSCROLL, TB_ENDTRACK, (LPARAM)GetDlgItem(hDlg, IDC_TRACK_REPLAYGAIN_PREAMP_WITHOUT_RG));

			CString buf = m_HelperIn.MyLoadString(IDS_LTRACKGAIN);
			SendDlgItemMessage(hDlg, IDC_COMBO_REPLAYGAIN_MODE, CB_ADDSTRING, 0, (LPARAM)(LPCSTR)buf);
			buf = m_HelperIn.MyLoadString(IDS_LALBUMGAIN);
			SendDlgItemMessage(hDlg, IDC_COMBO_REPLAYGAIN_MODE, CB_ADDSTRING, 0, (LPARAM)(LPCSTR)buf);

			SendDlgItemMessage(hDlg, IDC_COMBO_REPLAYGAIN_MODE, CB_SETCURSEL, prm->m_nReplayGainMode, 0);
			break;
		}
	case WM_HSCROLL:
		if (LOWORD(wParam) >= TB_THUMBTRACK && LOWORD(wParam) <= TB_ENDTRACK)
		{
			if ((HWND)lParam == GetDlgItem(hDlg, IDC_TRACK_REPLAYGAIN_PREAMP_WITH_RG))
			{
				ShowDB(hDlg, SendDlgItemMessage(hDlg, IDC_TRACK_REPLAYGAIN_PREAMP_WITH_RG, TBM_GETPOS, 0, 0), IDC_ST_REPLAYGAIN_PREAMP_WITH_RG_DB);
			}
			if ((HWND)lParam == GetDlgItem(hDlg, IDC_TRACK_REPLAYGAIN_PREAMP_WITHOUT_RG))
			{
				ShowDB(hDlg, SendDlgItemMessage(hDlg, IDC_TRACK_REPLAYGAIN_PREAMP_WITHOUT_RG, TBM_GETPOS, 0, 0),
					   IDC_ST_REPLAYGAIN_PREAMP_WITHOUT_RG_DB);
			}
		}
		break;
	case WM_NOTIFY:
		{
			LPPSHNOTIFY lppsn = (LPPSHNOTIFY)lParam;
			switch (lppsn->hdr.code)
			{
			case PSN_APPLY :
				{
					prm->m_bReplayGainEnable = SendDlgItemMessage(hDlg, IDC_CH_REPLAYGAIN_ENABLE, BM_GETCHECK, 0, 0) == BST_CHECKED ? 1 : 0;
					prm->m_nReplayGainTag = SendDlgItemMessage(hDlg, IDC_CH_REPLAYGAIN_TAG_ID3V2, BM_GETCHECK, 0, 0) == BST_CHECKED ?
											REPLAYGAIN_TAG_ID3V2 : REPLAYGAIN_TAG_NONE;
					prm->m_nReplayGainTag |= SendDlgItemMessage(hDlg, IDC_CH_REPLAYGAIN_TAG_APE, BM_GETCHECK, 0, 0) == BST_CHECKED ?
											 REPLAYGAIN_TAG_APE : REPLAYGAIN_TAG_NONE;
					prm->m_nReplayGainTag |= SendDlgItemMessage(hDlg, IDC_CH_REPLAYGAIN_TAG_LAME, BM_GETCHECK, 0, 0) == BST_CHECKED ?
											 REPLAYGAIN_TAG_LAME : REPLAYGAIN_TAG_NONE;
					prm->m_bReplayGainHardLimit = SendDlgItemMessage(hDlg, IDC_CH_REPLAYGAIN_HARDLIMIT, BM_GETCHECK, 0, 0) == BST_CHECKED ? 1 : 0;
					prm->m_nReplayGainPreAmpWithRG = SendDlgItemMessage(hDlg, IDC_TRACK_REPLAYGAIN_PREAMP_WITH_RG, TBM_GETPOS, 0, 0);
					prm->m_nReplayGainPreAmpWithoutRG = SendDlgItemMessage(hDlg, IDC_TRACK_REPLAYGAIN_PREAMP_WITHOUT_RG, TBM_GETPOS, 0, 0);

					bool bFlag = false;

					if (prm->m_nReplayGainMode != SendDlgItemMessage(hDlg, IDC_COMBO_REPLAYGAIN_MODE, CB_GETCURSEL, 0, 0))
					{
						prm->m_nReplayGainMode = SendDlgItemMessage(hDlg, IDC_COMBO_REPLAYGAIN_MODE, CB_GETCURSEL, 0, 0);
						bFlag = true;
					}
					if (bFlag)
					{
						::reflect_thread_setting();
					}
					::reflect_setting();
					break;
				}
			case PSN_QUERYCANCEL:
				EndDialog(hDlg, LOWORD(wParam));
				break;
			}
			break;
		}
	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
		case IDOK:
		case IDCANCEL:
		default:
			return FALSE;
		}
	default:
		return FALSE;
	}

	return TRUE;
}
